/*
mpcx_set

copies f to h; the size of h is preserved if it is bigger than necessary

Copyright (C) 2009 Andreas Enge

This file is part of the MPFRCX Library.

The MPFRCX Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.

The MPFRCX Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the MPC Library; see the file COPYING.LIB.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA.
*/

#include "mpfrcx-impl.h"

void mpcx_set (mpcx_ptr h, mpcx_srcptr f) {
   int i;

   if (h->size < f->deg + 1)
      mpcx_realloc (h, f->deg + 1);

   h->deg = f->deg;
   for (i = 0; i <= f->deg; i++)
      mpc_set (h->coeff [i], f->coeff [i], MPC_RNDNN);
}
